commit 98cd020ebc50a197de17aecd15afdff718cb06d3
Author: Martin Liska <mliska@suse.cz>
Date:   Wed Oct 21 09:28:56 2020 +0200

    libsanitizer: add test-case
    
    gcc/testsuite/ChangeLog:
    
            PR sanitizer/97414
            * g++.dg/asan/pr97414.C: New test.
    
    (cherry picked from commit 6c5b08a2ca935c5db68e79d33e5c5b752252115c)

diff --git a/gcc/testsuite/g++.dg/asan/pr97414.C b/gcc/testsuite/g++.dg/asan/pr97414.C
new file mode 100644
index 00000000000..6ea03906daa
--- /dev/null
+++ b/gcc/testsuite/g++.dg/asan/pr97414.C
@@ -0,0 +1,19 @@
+/* PR sanitizer/97414 */
+/* { dg-do run } */
+/* { dg-set-target-env-var ASAN_OPTIONS "detect_invalid_pointer_pairs=1:halt_on_error=1,detect_stack_use_after_return=1" } */
+/* { dg-options "-fsanitize=address,pointer-compare,pointer-subtract" } */
+
+[[gnu::noinline]] auto pointer_diff(const int *begin, const int *end) {
+  return end - begin;
+}
+
+int main() {
+  constexpr auto size = (2048 / sizeof(int)) + 1;
+
+  auto buf = new int[size];
+  auto end = buf + size;
+  pointer_diff(end, buf);
+  delete[] buf;
+
+  return 0;
+}

